const tcsContribSindical       = '1';
const tcsTaxaAssistencial      = '2';
const tcsCusteioConfederativo  = '3';
const tcsMensalidadeSindical   = '4';
const tcsReversaoSalarial      = '5';
const tcsPremioAdicComerciario = '6';

FormManager.afterCreateAllForms.subscribe(function() {
	let formMaster = FormManager.byname('TnFpaDMSindicato', '');
	let formConvencao = FormManager.byname('TnFpaDMSindConvencaoVigencia', '');
	let formSindical = FormManager.byname('TnFpaDMSindContribSindical', '');
	let formTaxaAssist = FormManager.byname('TnFpaDMSindContribTaxaAssistencial', '');
	let formCusteioConfed = FormManager.byname('TnFpaDMSindContribCusteioConfed', '');
	let formMensalidadeSind = FormManager.byname('TnFpaDMSindContribMensalidadeSind', '');
	let formReversaoSalarial = FormManager.byname('TnFpaDMSindContribMensalidadeSind', '');
	let formPremioAdicComerc = FormManager.byname('TnFpaDMSindContribPremioAdicComerc', '');
	let formFeriasAmpliada = FormManager.byname('TnFpaDMFeriasAmpliadaVigencia', '');

	formConvencao.afterCreateGridConteudo.subscribe(() => {
		let gridConvencao = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindConvencaoVigencia'));
		gridConvencao.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindConvencao', '', filter);
			}
		});
	});

	formSindical.afterCreateGridConteudo.subscribe(() => {
		let gridSindical = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindContribSindical'));
		gridSindical.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","CONTRIBSIND":"${tcsContribSindical}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindContrib', tcsContribSindical, filter);
			}
		});
	});

	formTaxaAssist.afterCreateGridConteudo.subscribe(() => {
		let gridTaxaAssist = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindContribTaxaAssistencial'));
		gridTaxaAssist.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","CONTRIBSIND":"${tcsTaxaAssistencial}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindContrib', tcsTaxaAssistencial, filter);
			}
		});
	});

	formCusteioConfed.afterCreateGridConteudo.subscribe(() => {
		let gridCusteioConfed = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindContribCusteioConfed'));
		gridCusteioConfed.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","CONTRIBSIND":"${tcsCusteioConfederativo}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindContrib', tcsCusteioConfederativo, filter);
			}
		});
	});

	formMensalidadeSind.afterCreateGridConteudo.subscribe(() => {
		let gridMensalidadeSind = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindContribMensalidadeSind'));
		gridMensalidadeSind.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","CONTRIBSIND":"${tcsMensalidadeSindical}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindContrib', tcsMensalidadeSindical, filter);
			}
		});
	});

	formReversaoSalarial.afterCreateGridConteudo.subscribe(() => {
		let gridReversaoSalarial = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindContribReversaoSalarial'));
		gridReversaoSalarial.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","CONTRIBSIND":"${tcsReversaoSalarial}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindContrib', tcsReversaoSalarial, filter);
			}
		});
	});

	formPremioAdicComerc.afterCreateGridConteudo.subscribe(() => {
		let gridPremioAdicComerc = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMSindContribPremioAdicComerc'));
		gridPremioAdicComerc.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","CONTRIBSIND":"${tcsPremioAdicComerciario}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMSindContrib', tcsPremioAdicComerciario, filter);
			}
		});
	});

	formFeriasAmpliada.afterCreateGridConteudo.subscribe(() => {
		let gridFeriasAmpliada = dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMFeriasAmpliadaVigencia'));
		gridFeriasAmpliada.option("onRowClick", (row) => {
			const { CODIGOSIND, DATAINICIAL } = row.data;
			if ((CODIGOSIND) && (DATAINICIAL)) {
				const filter = `{"CODIGOSIND":"${CODIGOSIND}","DATAINICIAL":"${moment(DATAINICIAL).format('YYYY-MM-DD')}"}`;
				atualizarDetalhe('TnFpaDMFeriasAmpliada', '', filter);
			}
		});
		FormManager.byname('TnFpaDMFeriasAmpliada', '').AfterLoadData = () => {
			dxDataGrid.getInstance($('#dataGridConteudoTnFpaDMFeriasAmpliadaDet')).refresh();
		}
	});

	function atualizarDetalhe(formClass, alias, filter) {
		FormManager.loadCadastro({
			_ACadastro: formClass,
			_AAlias: alias,
			_AFiltros: filter
		});
	}
});