{
	function validateDataHistorico() {
		const form = this;
		if (form.estado === FormState.cadInset) {
			let dataHistorico = form.fieldbyName('DATAHISTORICO');
			let dataInicial = form.fieldbyName('DATAINICIAL');
			dataHistorico.setvalue(dataInicial.getvalue());
		}
		else if (form.estado === FormState.cadAlterando) {
			const mapFields = ({
				SOCIORESPCNPJ
			}) => ({
				SOCIORESPCNPJ
			});
			const convertNullToEmptyString = (obj) => Object.entries(obj).reduce((newObj, [key, value]) => ({ ...newObj, [key]: value || '' }), {});
			const getLastData = (data) => {
				return !data.datadetalhes 
					? data
					: data.datadetalhes.find(({ _AAlias, Class}) => (Class === 'TnGemDMCfgEmpresaGem' && _AAlias === 'empresagem'));
			};  

     		const previousData = getLastData(FormManager.ultimosDadosCadastro);
			const currentData = form.getValues();
			const hasChanges = !_.isEqual(mapFields(previousData), convertNullToEmptyString(mapFields(currentData)));
	
			if (hasChanges) {				
				return askDate(form);
			}
		}
	
		return Promise.resolve();
	}

	function askDate(form) {
		return new Promise((resolve, reject) => {
			const dialog = bootbox.dialog({
				title: 'Gravar Histórico Informações Alteradas',
				message: `<label  class="col-form-label">
							<span data-text>Data Histórico</span>		
							<span data-span-required>*</span>
						</label>
						<div class="input-group">
							<div class="input-group">
								<div class="input-group-prepend">
									<span class="input-group-text btn btn-icon  input-group-text">
										<i class="far fa-calendar-alt"></i>
									</span>
								</div>
								<input autocomplete="off" type="text" data-mask="00/00/0000" class="form-control kt-input datepicker" required>
							</div>
							<input type="hidden" id="DATAHISTORICO_modal"/>
						</div>`,
				buttons: {
					ok: {
						label: "Confirmar",
						className: 'btn-secondary text-white',
						callback: function(){
							var value =  $('#DATAHISTORICO_modal').val();
							var field = form.fieldbyName('DATAHISTORICO');

							if (value) {
								field.setvalue(value);
								resolve();
							}
							else {
								FormatErrorMessage('Data inválida, informe novamente');
								reject();
							}	
						}
					}
				}
			});
	
			dialog.init(function() {
				let input = $('.bootbox input.datepicker');

				$.applyDataMask(input);

				configureDatepicker($('.bootbox .datepicker'));
			});
		});
	}

	FormManager.afterCreateAllForms.subscribe(function () {			
		FormCfgEmpresaGem = FormManager.byname('TnGemDMcfgEmpresaGem', 'empresagem');
		FormCfgEmpresaGem.BeforePost = validateDataHistorico;
	}); 
}