let estaFechandoBigData = false;
{
	function validateDataHistorico() {
		const form = this;

		if (form.estado === FormState.cadInset) {
			let dataHistorico = form.fieldbyName('DATAHISTORICO');
			let dataInicial = form.fieldbyName('DATAINICIAL');
	
			dataHistorico.setvalue(dataInicial.getvalue());
		}
		else if (form.estado === FormState.cadAlterando) {
			const mapFields = ({
				NOMEESTABCOMPLETO,
				NOMEFANTASIA,
				TIPOINSCR,
				INSCRFEDERAL,
				CODIGOTIPOLOGRAD,
				ENDERECOESTAB,
				COMPLENDERESTAB,
				NUMENDERESTAB,
				BAIRROENDERESTAB,
				SIGLAESTADO,
				CODIGOMUNIC,
				CEPENDERESTAB,
				CODIGOATIVFEDERAL,
				DESCRATIVFEDESTAB,
				NUMEROREGIST,
				INSCRESTAD,
				CODIGOATIVESTAD,
				DESCRATIVESTESTAB,
				CODIGOATIVMUNIC,
				DESCRATIVMUNESTAB
			}) => ({
				NOMEESTABCOMPLETO,
				NOMEFANTASIA,
				TIPOINSCR,
				INSCRFEDERAL,
				CODIGOTIPOLOGRAD,
				ENDERECOESTAB,
				COMPLENDERESTAB,
				NUMENDERESTAB,
				BAIRROENDERESTAB,
				SIGLAESTADO,
				CODIGOMUNIC,
				CEPENDERESTAB,
				CODIGOATIVFEDERAL,
				DESCRATIVFEDESTAB,
				NUMEROREGIST,
				INSCRESTAD,
				CODIGOATIVESTAD,
				DESCRATIVESTESTAB,
				CODIGOATIVMUNIC,
				DESCRATIVMUNESTAB
			});
			const convertNullToEmptyString = (obj) => Object.entries(obj).reduce((newObj, [key, value]) => ({ ...newObj, [key]: value || '' }), {});
			const getLastData = (data) => {
				return !data.datadetalhes 
					? data
					: data.datadetalhes.find(({ _AAlias, Class}) => (Class === 'TnGemDMEstab' && _AAlias === 'Estab'));
			};  

     		const previousData = getLastData(FormManager.ultimosDadosCadastro);
			const currentData = form.getValues();
			const hasChanges = estaFechandoBigData || previousData == undefined || !_.isEqual(mapFields(previousData), convertNullToEmptyString(mapFields(currentData)));
	
			if (hasChanges) {				
				return askDate(form);
			}
			estaFechandoBigData = false;
		}
	
		return Promise.resolve();
	}

	function askDate(form) {
		return new Promise((resolve, reject) => {
			const dialog = bootbox.dialog({
				title: 'Gravar Histórico Informações Alteradas',
				message: `<label  class="col-form-label">
							<span data-text>Data Histórico</span>		
							<span data-span-required>*</span>
						</label>
						<div class="input-group">
							<div class="input-group">
								<div class="input-group-prepend">
									<span class="input-group-text btn btn-icon  input-group-text">
										<i class="far fa-calendar-alt"></i>
									</span>
								</div>
								<input autocomplete="off" type="text" data-mask="00/00/0000" class="form-control kt-input datepicker" required>
							</div>
							<input type="hidden" id="DATAHISTORICO_modal"/>
						</div>
						<label  class="col-form-label">
						 <span data-text>Atualizar dados no Questor Zen</span>		
						 <span data-span-required>*</span>
					   </label>
					   <div class="select-input">
					     <select onfocus="focusImputFunc({element: this})" class="form-control kt-input cad-control cad-logchange ctrlATUALIZASINC " id="ctrlATUALIZASINC" name="p.SOCIEDADECONTAPARTICIPACAO" title="Informe sim caso o estabelecimento seja uma Sociedade em Conta de Participação" value="" data-dicionario="DICSIMNAO" required="" data-classname="TnGemDMEstab" data-alias="Estab">
						 <option value="1">Sim</option>
						 <option value="0">Não</option>
					   </select>`,
				buttons: {
					ok: {
						label: "Confirmar",
						className: 'btn-secondary text-white',
						callback: function(){
							var value =  $('#DATAHISTORICO_modal').val();
							var field = form.fieldbyName('DATAHISTORICO');

							if (value) {
								field.setvalue(value);
								resolve();
							}
							else {
								FormatErrorMessage('Data inválida, informe novamente');
								reject();
							}

							 var value =  $('#ctrlATUALIZASINC').val();								 				
							 if (value == 1) {						

								let filter = {
									'CodigoEmpresa': form.getvalue('CODIGOEMPRESA'),
									'CodigoEstab': form.getvalue('CODIGOESTAB')
								};

								ActExecuteProcesso({
									_AClass: 'TnGemDPSincronizarCadastros',
									_AParams: filter,									
								});
							 };		
						}
					}
				}
			});
	
			dialog.init(function() {
				let input = $('.bootbox input.datepicker');

				$.applyDataMask(input);

				configureDatepicker($('.bootbox .datepicker'));
			});
		});
	}

	FormManager.afterCreateAllForms.subscribe(function () {	
		let FormEstab = FormManager.byname('TnGemDMEstab', 'Estab');
		let FieldEstab = FormEstab.fieldbyName('NOMEESTAB');
		let FieldEstabCompleto = FormEstab.fieldbyName('NOMEESTABCOMPLETO');	
		let NomeEstabOld = FieldEstab.getvalue();
		
		FieldEstab.componente.on('focus', function(){ChangeNomeEstab(FormEstab)});
		FieldEstabCompleto.componente.on('focus', function(){ChangeNomeEstabCompleto(FormEstab, NomeEstabOld)});	
		
		FormEstab.BeforePost = validateDataHistorico;

		$('#detalheModal').on('hide.bs.modal', function(e) {			
			if (e.target.outerHTML.indexOf('TnGemDPAtualizaEstabBigData') > 0) {
				estaFechandoBigData = true;
				FormEstab.estado = FormState.cadAlterando;
				FormEstab.executeAction('actDataSetPostExecute', 'btnpost1', { forcePostType: true });
			}
		});
	});
}

function ChangeNomeEstab(formularioEstab) {
	let formEmpresa = FormManager.byname('TnGemDMEmpresa', '');	
	var NomeEstab = formularioEstab.getvalue('NOMEESTAB');
	var CodEmpresa = formEmpresa.getvalue('CODIGOEMPRESA');
	var NomeEmpresa = formEmpresa.getvalue('NOMEEMPRESA');
	console.log('NomeEstab',NomeEstab)
	console.log('CodEmpresa', CodEmpresa)
	console.log('NomeEmpresa', NomeEmpresa)
	if ((formularioEstab.estado == FormState.cadInsert) && (CodEmpresa != null) && (NomeEstab == ''))  {
		formularioEstab.fieldbyName('NOMEESTAB').setvalue(NomeEmpresa)
	}
}

function ChangeNomeEstabCompleto(formularioEstab, NomeEstabOld) {
	var NomeEstabCompleto = formularioEstab.getvalue('NOMEESTABCOMPLETO');	
	var NomeEstabAtual = formularioEstab.getvalue('NOMEESTAB');
	
	if ((NomeEstabCompleto != '') &&  (NomeEstabOld != NomeEstabAtual)) {
		formularioEstab.fieldbyName('NOMEESTABCOMPLETO').setvalue(NomeEstabAtual)
	}
}