import purgecssWebpackPlugin from "purgecss-webpack-plugin";
import glob from 'glob';
import path from 'path';


export const getPurgeCssConfig = () => {
    const getFilesPurgeCss = (dirPath: string) => glob.sync(path.resolve(__dirname, dirPath),  { nodir: true });
    
    const purgeCssFiles = {
        js: getFilesPurgeCss('js/**/*'),
        ts: getFilesPurgeCss('ts/**/*'),
        views: getFilesPurgeCss('../*.{html,partial}'),
        metronic: getFilesPurgeCss('metronic/**/*'),
        pagesJs: getFilesPurgeCss('../../../../../Questor/javascript/**/*'),
        vendors: getFilesPurgeCss('vendors/**/*'),
        template: getFilesPurgeCss('template/**/*')
    };

    return new purgecssWebpackPlugin({
        // only: ['qcloud'], // TODO: Verify issue https://github.com/FullHuman/purgecss/issues/881
        paths: [
            ...purgeCssFiles.views,
            ...purgeCssFiles.js,
            ...purgeCssFiles.ts,
            ...purgeCssFiles.metronic,
            ...purgeCssFiles.pagesJs,
            ...purgeCssFiles.vendors,
            ...purgeCssFiles.template,
        ],
        safelist: [ // dinamically added classes
            /^la-/,
            /^flaticon-/,
            /^kt--font/,
            /^kt--bg/,
            /^dx-/
        ]
    });
};