import FormManager from '../../FormManager';
import { initLookupStyle } from '../../nLookUp';
import { CarregarDataCadastro } from '../../nWebUtil';

export function runEndPageScript(args) {
	if (FormManager.afterCreateAllForms.isStopped) ScriptCadastro.script(args);
	else FormManager.afterCreateAllForms.subscribe(() => ScriptCadastro.script(args));
}

class ScriptCadastro {
	static script({ scope }) {
		ScriptCadastro.setLinkConsultaOrigem(scope);
		ScriptCadastro.handleScopeEhModal(scope);
		ScriptCadastro.handleScopeNew(scope);
		
		PrepararMaskDefault();
		initLookupStyle(scope.DefinicaoObjetos.MultiColuna);
	}

	static setLinkConsultaOrigem({ DefinicaoObjetos }) {
		FormManager.LinkConsultaOrigem = `RedirectPage?Scope={Class:"${DefinicaoObjetos.Class}"}`;
	}

	static handleScopeEhModal({ EhModal, Filtros, ChaveMestre, Sugerir } = {}) {
		if (EhModal) {
			const form = FormManager.itens.firstUsable();

			form.detailfields = ChaveMestre;
			form.suggestionFields = Object.keys(Sugerir || {});

			FormManager.FiltroModal = Filtros;
			FormManager.SuggestionFieldValues = Sugerir;
		}
	}

	static handleScopeNew({ new: New, Filtros, Class, data, redirect } = {}) {
		if (New) {
			FormManager.Scopenew = true;

			FormManager
				.itens
				.firstUsable()
				.executeAction('actDataSetInsertExecute');
		}
		else {
			FormManager.Scopenew = false;

			if (redirect) {				
				let form = FormManager.byname(Class);
				form.executeAction('actDataSetRefreshExecute');
			}
			if (data) {
				FormManager.filterForCadGrid = Filtros;

				$(() => {
					CarregarDataCadastro(data);

					FormManager.itens
						.firstUsable()
						?.focusFirstField();
				});
			}
			else if (Filtros) {
				FormManager.loadCadastro({_ACadastro: Class, _AAlias: '', _AFiltros: Filtros}).then(() => {
					let form = FormManager.byname(Class);
					form.focusFirstField();
				});
			}
		}
	}
}