import { FormatErrorMessage } from "../../nWebUtil";

export const runEndPageScript = () => bindTOUEvents();

export function bindTOUEvents() {
    const modal = $('#termsOfUseModal');
    const inputAcceptTOU = insertAcceptTOUInput();
	
    bindLoginButtonHandler({ inputAcceptTOU, modal });
    bindAcceptButtonHandler({ inputAcceptTOU });
    bindDismissModalHandler({ inputAcceptTOU, modal });
    
    modal.modal('show');	
};

const insertAcceptTOUInput = () => {
    const input = $('<input type="hidden" name="AceiteTermo" value="0">');

    $('form').append(input);

    return input;
};

const bindLoginButtonHandler = ({ inputAcceptTOU, modal }) => {
    $('button#m_login_signin_submit').on('click', (event) => {
        if (inputAcceptTOU.val() != '0') return 

        event.preventDefault();

		modal.modal('show');
	});
};

const bindAcceptButtonHandler = ({ inputAcceptTOU }) => {
	$('button#accept_terms').on('click', () => {
        inputAcceptTOU.val('1');

        $('form').trigger('submit');		
    });
};

const bindDismissModalHandler = ({ modal, inputAcceptTOU }) => {
    modal.on('hide.bs.modal', () => {
		if (inputAcceptTOU.val() == '1') return;

		console.log('hide modal');

        FormatErrorMessage('Para uso do produto é necessário fazer o aceite dos Termos');
	})
};