const _AFormNameContabTemp = 'TnDMContabilizacaoTemp';
	
function AfterSave(FormularioCreditoFederalBase) {
	FormularioCreditoFederalBase.AfterSave.subscribe(function() {
		AbrirContabilizacao();
	});
}

function FrameModal(contentWindow) {
	if (!contentWindow.FormManager) return;
		
	let saved = false;
	contentWindow.FormManager.runAfterCreateAllForms((FormManagerModal, items) => {
		const formfirstUsable = items.firstUsable();
		if (formfirstUsable) {
			formfirstUsable.AfterSave.subscribe(function() {
				saved = true;
			});
		}
	});
	
	return saved;
}

function ExecutarValidarContabilizacaoCloud(contentWindow, saved) {
	let modal = contentWindow.FormManager.byname(_AFormNameContabTemp);
	
	if (modal) {
		let params = {};
		params.sequencial = modal.getvalue('SEQUENCIAL');
		if (saved) {
			AJaxCadastroExecuteMethodGetProperty(_AFormName, 'ValidarContabilizacaoCloud', JSON.stringify(params), '', ValidarContabilizacaoCloud);
		}
	}
}

function AbrirCadastroDM(retorno){
	let result = retorno.data.result; 
	let filtro = {};

	if (result.InformarLcto) {
		filtro.SEQUENCIAL = result.Sequencial;
		filtro.INFORMAR   = 1;		

		AbrirCadastroModal({
			_AClasse: _AFormNameContabTemp,
			AFiltros: filtro,
			AGrid: null,
			ANovo: false,
			AChaveMestre: ['SEQUENCIAL', 'CODIGOEMPRESA', 'CHAVEORIGEM', 'SEQ'],
			AClasseForm: null,
		});
	}
}

function AbrirContabilizacao(){
	let form = FormManager.byname(_AFormName, '');
	let params = form.getValues();
	
    AJaxCadastroExecuteMethodGetProperty(_AFormName, 'ContabilizarCloud', JSON.stringify(params), '', AbrirCadastroDM);	
}

function ValidarContabilizacaoCloud(retorno) {
    let form = FormManager.byname(_AFormName, '');
	let result = retorno.data.result; 
    let params = {};

	if (result.PossuiDiferenca) {
		criarDialogSimNao('Existem diferenças nos lançamentos contábeis! Deseja corrigir os lançamentos?', 
		                  'Confirmação', 
    		              (a) => { AbrirCadastroDM(retorno) }); 
	} else {
		params.params     = form.getValues(); 
		params.Sequencial = result.Sequencial;
		AJaxCadastroExecuteMethodGetProperty(_AFormName, 'FinalizarContabilizacaoCloud', JSON.stringify(params), '', (retorno) => {});
	}
}

export { 
	AfterSave,
	FrameModal,
	ExecutarValidarContabilizacaoCloud 
}