export function insertHelpButton({ hint, defaultStep, stepConfig } = {}) {
	IntroJsHelper.insertHelpButton({ hint, defaultStep, stepConfig });
}

export class IntroJsHelper {
	static insertHelpButton({ hint, defaultStep, stepConfig } = {}) {
		if (!$("#btnHelpIntroJs").length) {
			let button = $(`
				<div class="kt-portlet__nav-item" style="opacity: 0; transition: opacity 1.5s">
					<a 
						id="btnHelpIntroJs"
						href="#"
						data-toggle="kt-tooltip"
						class="btn btn-icon btn-sm btn-icon-md"
						data-direction="left"
						data-width="auto"
						title=""
						data-original-title="${hint || ""}">
						<i class="flaticon-info"></i>
					</a>	
				</div>
			`);
			
			$(".card-toolbar").eq(1).prepend(button);
			
			button.on('click', () => IntroJsHelper.beginIntroJs(stepConfig, defaultStep));
			setTimeout(() => button.css('opacity', 1));
		}
	}

	static beginIntroJs(stepConfig, defaultStep) {
		let idTab = $(".tab-pane.wizardtab.active").first().attr("id");

		IntroJsHelper.startHelpBox(stepConfig, idTab || defaultStep);
	}

	static startHelpBox(stepConfig, step) {
		var intro = IntroJsHelper.introJs();
		var steps = IntroJsHelper.buildSteps(stepConfig[step].steps)

		intro.setOptions({
			steps: steps
		});
		intro.start()
	}

	static introJs() {
		const intro = introJs();

		intro.setOptions(
			{
				"doneLabel": "Finalizar",
				"nextLabel": "Próximo",
				"prevLabel": "Voltar",
				"skipLabel": "Pular",
				"showProgress": "true"
			}
		);

		return intro;
	}

	static buildSteps(steps) {
		let buildedSteps = [];

		steps.forEach(step => {
			buildedSteps.push({
				element: IntroJsHelper.getElementForIntro(step),
				intro: IntroJsHelper.setStepContent(step),
				step: step.step,
				group: step.group
			});
		});

		return buildedSteps;
	}

	static getElementForIntro(step) {
		let element = step.element;
		let mobileEl = step.mobileElement;

		if (mobileEl) {
			var el = mobileEl.id ? document.getElementById(mobileEl.id) : document.getElementsByClassName(mobileEl.class)[mobileEl.indexClass];
			if (el.offsetParent) return el;
		}

		return element.id ? document.getElementById(element.id) :
			document.getElementsByClassName(element.class)[element.indexClass];
	}

	static setStepContent(step) {
		return `<h5 style="text-align:center">${step.title || ""}</h5> <p style="text-align: left"> ${step.text || ""} </p>`;
	}
}