class WizardManager {
	constructor () {
		this._context = null;
		this._customEvent = new Map();
	}

	get context() {
		return this._context;
	}

	getAll() {
		let wizard = [];
		for (let element in KTUtilElementDataStore)
			if ("wizard" in KTUtilElementDataStore[element])
				wizard.push(KTUtilElementDataStore[element].wizard)
		return wizard;
	}

	getById(id) {
		for (let element in KTUtilElementDataStore)
			if ("wizard" in KTUtilElementDataStore[element] && ((KTUtilElementDataStore[element].wizard || {}).element || "").id == id)
				return KTUtilElementDataStore[element].wizard;
		return null;
	}

	getFirst() {
		for (let element in KTUtilElementDataStore)
			if ("wizard" in KTUtilElementDataStore[element])
				return KTUtilElementDataStore[element].wizard;
		return null;
	}

	GoToWizardNext(Item, blockPageMode) {
		if (this._customEvent.has(this._context.DetalheAtivo.toUpperCase())) {
			this._customEvent.get(this._context.DetalheAtivo.toUpperCase())();
		}
		else {
			GoToWizardItem(Item, blockPageMode);
		}
	}

	setContext(context) {
		this._context = context;
	}

	/** 
	 * @param actualStep Class of form
	 * @param handler Function that is executed after click in button
	 * 
	 * Executes a custom function on the next's button click given the class of a step 
	 */
	setCustomEvent(actualStep, handler) {
		this._customEvent.set((actualStep || '').toUpperCase(), handler);
	}

	getCustomEvent(customEvent) {
		return this._customEvent.get((customEvent || '').toUpperCase());
	}
}

export default (new WizardManager())