import { BaseAction } from "./BaseAction";
import { FormState } from "../../nCadastro";
import { OperacaoCadastro } from "../../nWebUtil";

export class actDataSetDeleteExecute extends BaseAction {
	constructor(options) {
		super(options);

		this._handler = options.handler; // can be null, ex formRepeater
	}

	execute(event) {
		if (this.isToolbuttonDisabled())
			return;

		swal
			.fire({
				text: "Deseja realmente excluir o registro?",
				type: 'warning',
				showCancelButton: true,
				confirmButtonClass: "btn btn-q-action"
			})
			.then((result) => {
				if (result.value) {
					if (this._form.BeforeDelete) {
						let retorno = this._form.BeforeDelete(this._element, CadastroGetImputData(this._form));
						if (retorno == undefined || (typeof retorno === 'boolean' && retorno)) {
							this._DeleteRegistroCadastro(event);
						} else if (retorno.then instanceof Function) {
							retorno.then(() => {
								this._DeleteRegistroCadastro(event);
							});
						}
					} else {
						this._DeleteRegistroCadastro(event);
					}
				}
			});
	}

	_DeleteRegistroCadastro(event) {
		let response = OperacaoCadastro({
			_AClasse: this._form.classe,
			_Aoperacao: 'CadastroExcluir',
			_AAlias: this._form.alias
		});

		this._form.focusFirstField();
		FormManager.ultimosDadosCadastro = null
		this._form.changeState(FormState.cadLimpo);

		this._onExecuted.next({ originalEvent: event, response });
	}
}