import { BaseAction } from "./BaseAction";
import { FormState } from "../../nCadastro";
import FormManager from "../../FormManager";
import SessionManager from "../../SessionManager";

export class actDataSetRefreshExecute extends BaseAction {
	constructor(options) {
		super(options);
	}

	execute() {
		if (this.isToolbuttonDisabled())
			return;

		this._form.limparAtencaoFields();

		let Filtros = this._form.MontarFiltroChavePrimaria();

		if (!Object.keys(Filtros).length) {
			this._form.chaveprimaria?.forEach((pKey) => {
				if (SessionManager.selecao.hasOwnProperty(pKey)) {
					Filtros[pKey] = SessionManager.selecao[pKey];
				}
			});
		}

		FormManager.loadCadastro({
			_ACadastro: this._form.classe,
			_AAlias: this._form.alias,
			_AFiltros: Filtros,
			_AOrigem: ''
		})
			.then(() => {
				this._form.focusFirstField();
				this._form.changeState(FormState.cadNavegando)
			});
	}
}