import { TwMsgLista } from "../../../../ts/components/widgets/tw-msg-lista/tw-msg-lista";
import { CarregarTreeList } from "../../../treeview/treeview";

export function clearAllReponseBox() {
	$('div[data-treeview-wrapper]').each((index, el) => {
		import('jstree').then(() => {
			const responseEl = $(el).find('div[data-action-response]').exists();

			if (responseEl) {
				responseEl.jstree('destroy');
			}

			$(el).remove();
		})
	});

	$('div[data-action-response-msg-list]').each((index, el) => {
		try {
			dxDataGrid.getInstance(el.firstChild).dispose();
		}
		finally {
			$(el).remove();
		}
	})
}

export function handleResponseBox(grid, { MsgTreeLista, MsgLista } = {}) {
	const getComponent = (grid) => {
		try {
			return typeof grid === 'string' ? dxDataGrid.getInstance(`#dataGridConteudo${grid}`) : grid;
		}
		catch {
			return null;
		}
	};

	let gridComponent = getComponent(grid);


	if (gridComponent) {
		handleTreeViewResponseBox(gridComponent, MsgTreeLista);
		handleListResponseBox(gridComponent, MsgLista);
	}
}

function handleTreeViewResponseBox(gridComponent, treeview) {
	let gridEl = gridComponent.element();
	let responseActionEl = gridEl.parent().find('div[data-action-response]').exists();
	let { Tree } = (treeview || {});

	if (responseActionEl) {
		import('jstree').then(() => {
			responseActionEl.jstree('destroy');
			
			if (!treeview) {
				responseActionEl.closest('div[data-treeview-wrapper]').remove();
				
				return;
			}
			
			responseActionEl.data('tree-content', Tree);
			CarregarTreeList(null, responseActionEl);
		})
	}
	else {
		if (!treeview) return;

		let treeviewWrapper = $(
			`<div class="row" data-treeview-wrapper="true">
				<div class="card card-custom kt-portlet--bordered kt-portlet--rounded kt-portlet--unair kt-portlet--head-sm mt-4 w-100">
					<div class="card-header">
						<h3 class="h2 card-title">
							<span class="mr-2">
								<i class="fa fa-tag">
								</i>
							</span>
							Resultados
						</h3>
					</div>
					<div class="card-body">
						<div data-action-response="true"></div>
					</div>
				</div>
			</div>`
		);
		let treeviewEl = treeviewWrapper.find('div[data-action-response');

		treeviewEl.data('tree-content', Tree);

		gridEl.append(treeviewWrapper);

		CarregarTreeList(null, treeviewEl);
	}
}

function handleListResponseBox(gridComponent, MsgLista) {
	let gridEl = gridComponent.element();
	let actionReponseEl = gridEl.parent().find('div[data-action-response-msg-list]').exists();

	const createMsgLista = (elToAppend, MsgLista, { replace } = {}) => {
		const msgListaEl = TwMsgLista({
			widget: {
				MsgLista,
				Name: 'MsgListaResponseBox',
				twMsgLista: true,
				Visible: true,
			}
		});

		if (replace) {
			elToAppend.append(msgListaEl);
		}
		else {
			const div = $('<div data-action-response-msg-list="true">');

			div.append(msgListaEl);

			elToAppend.append(div);
		}
	}

	if (actionReponseEl) {
		const msgListaEl = actionReponseEl.get(0)?.firstChild;

		if (msgListaEl) {
			try {
				dxDataGrid.getInstance(msgListaEl)?.dispose();
			}
			finally {
				$(msgListaEl).remove();
			}

			if (!MsgLista) {
				actionReponseEl.remove();

				return;
			}

			createMsgLista(actionReponseEl, MsgLista, { replace: true });
		}
	}
	else {
		if (!MsgLista) return;

		createMsgLista(gridEl, MsgLista);
	}
}