import dxDataGrid from 'devextreme/ui/data_grid';
import dxButton from 'devextreme/ui/button';
import dxDropDownButton from 'devextreme/ui/drop_down_button';
import ptMessages from 'devextreme/localization/messages/pt.json';
import { locale, loadMessages } from 'devextreme/localization';
import { createGrid, createGridBase64, evaluateGridConfig, prepareGridConfig } from './gridConfigurator';
import { qGrid } from './grid';
import { nExpressionExecutor } from './nExpressionExecutor';
import { registerPrototypes } from './registerPrototypes';
import Initializer from './initializer';
import { carregarDadosDoCEP, PrepararMaskDefault } from './nEndereco';
import { carregarDadosRFB } from './nWebService';
import { exporter, loadBase64File, showThumbnail, downloadFileFromData, aplicarCriptografia, downloadArquivoTemp } from './nArquivos';
import { fixLookupFields, recoverLookupFields, saveLookupFields, FindLookupValue } from './nLookUp';
import {
	cxGridIncluirFiltroMaster, AddColumnButtonsCadastro,
	AbrirCadastroModal, loadData, dxdatagridDateFilterRevert, dxdatagridDateFilter, GetColorFromValoresCores,
	createdxDatasource,
	rowDataValues,
	ActionExecutarOperacaoDataSet,
	GridActionHelper,
	fixRowValues
} from './nGrid';
import { criarDialogSimNao, criarDialogOk, FormatErrorMessage, VerificaConfirmacaoAction } from './nDialog';
import { createAccordion, addAccordionClassField } from './nExpandables';
import WizardManager from './WizardManager';
import { nFraControl } from './nFraControl';
import { createContextMenu } from './ContextMenu';
import { ControleBaseIsentaOutras } from './nControleBaseIsentaOutras';
import { FormState } from './nCadastro';
import SessionManager from './SessionManager';
import { RequestDadosCadastro, PostWithForm } from './nRequests';
import { CarregarCheckTreeView } from './treeview/treeview';

import 'devextreme/dist/css/dx.common.css';
import 'devextreme/dist/css/dx.light.compact.css';
import { CustomStoreArray } from './grid/CustomStoreArray';
import { configureDatepicker, setDatePicker } from './setDatepicker';
import { createFormRepeater } from '../ts/components/form-repeater/create-form-repeater';
import { createNtcGrid } from '../ts/components/fra-control/ntc-grid/create-ntc-grid';
import { createNtcLinkAnnotation } from '../ts/components/fra-control/ntc-link-annotation/create-ntc-link-annotation';
import { Layout } from '../ts/components/widgets/layout/layout';
import { getToolButtonAction, executeActionFromPartial } from '../ts/components/toolbuttons/toolbutton-action/toolbutton-action';
import { createDropdownButton } from '../ts/components/toolbuttons/dropdown-button/create-dropdown-button';
import { take, first, filter } from 'rxjs/operators';
import { createFooterToolbuttons } from '../ts/components/toolbuttons/toolbuttons';
import { openPdf } from '../ts/pages/relatorio-exibir/open-pdf';
import gridManager from '../ts/components/grid-manager/grid-manager';
import { createNtcMemoAnnotation } from '../ts/components/fra-control/ntc-memo-annotation/create-ntc-memo-annotation';
import { ControlType } from './nFormulario';
import { createWizardNavigationToolbar } from '../ts/components/wizard-navigation/wizard-navigation';
import widgetManager from '../ts/components/widgets/widget-manager';
import { ActExecuteProcesso } from './form/actions/ActExecuteProcesso';
import { clearAllReponseBox } from './grid/actions/messageBox/handleReponseBox';
import brodcastManager from '../ts/utils/broadcast-manager/broadcast-manager';
import axios from 'axios';
import { AbrirCadastro, AbrirProcesso, AbrirProcessoModal, AJaxCadastroExecuteMethodGetProperty, AJaxProcessoExecuteMethodGetProperty, CadastroExecuteAction, CadastroGetImputData, DoExecuteReport, DoExecuteReportWithParams, FrameModalLoad, OperacaoCadastro, ProcessoExecuteAction, RemoverTabCadastro, RestoreTabsCadastro, RetornarData } from './nWebUtil';
import qNotifier from '../ts/components/notifier/q-notifier';
import _ from 'lodash';
import bootbox from 'bootbox';
import '../metronic/demo1/plugins/custom/jstree/jstree.bundle.css';
import '../template/empresarialHead/app.min.css';
import '../template/compact.css';
import '../css/custom.css';
import '../css/custom-icons.css';
import '../css/dx.generic.questor.css';
import '../vendors/line-awesome-1.3.0/css/line-awesome.min.css';

/**
 * Expose functions to global escope
 */

window.first = first;
window.take = take;
window.filter = filter;
window.createGrid = createGrid;
window.createGridBase64 = createGridBase64;
window.dxButton = dxButton;
window.dxDropDownButton = dxDropDownButton;
window.dxDataGrid = dxDataGrid;
window.evaluateGridConfig = evaluateGridConfig;
window.nExpressionExecutor = nExpressionExecutor;
window.prepareGridConfig = prepareGridConfig;
window.qGrid = qGrid;
window.carregarDadosDoCEP = carregarDadosDoCEP;
window.carregarDadosRFB = carregarDadosRFB;
window.PrepararMaskDefault = PrepararMaskDefault;
window.exporter = exporter;
window.loadBase64File = loadBase64File;
window.showThumbnail = showThumbnail;
window.fixLookupFields = fixLookupFields;
window.recoverLookupFields = recoverLookupFields;
window.saveLookupFields = saveLookupFields;
window.FindLookupValue = FindLookupValue;
window.downloadFileFromData = downloadFileFromData;
window.cxGridIncluirFiltroMaster = cxGridIncluirFiltroMaster;
window.AddColumnButtonsCadastro = AddColumnButtonsCadastro;
window.AbrirCadastroModal = AbrirCadastroModal;
window.loadData = loadData;
window.dxdatagridDateFilterRevert = dxdatagridDateFilterRevert;
window.dxdatagridDateFilter = dxdatagridDateFilter;
window.criarDialogSimNao = criarDialogSimNao;
window.criarDialogOk = criarDialogOk;
window.FormatErrorMessage = FormatErrorMessage;
window.createAccordion = createAccordion;
window.addAccordionClassField = addAccordionClassField;
window.WizardManager = WizardManager;
window.nextFocus = nFraControl.nextFocus;
window.FraControlKeyPress = nFraControl.FraControlKeyPress;
window.FraControlChange = nFraControl.FraControlChange;
window.createContextMenu = createContextMenu;
window.GetColorFromValoresCores = GetColorFromValoresCores;
window.rowDataValues = rowDataValues;
window.createdxDatasource = createdxDatasource;
window.ControleBaseIsentaOutras = ControleBaseIsentaOutras;
window.focusImputFunc = nFraControl.focusInputFunc;
window.FormState = FormState;
window.SessionManager = SessionManager;
window.RequestDadosCadastro = RequestDadosCadastro;
window.PostWithForm = PostWithForm;
window.ActionExecutarOperacaoDataSet = ActionExecutarOperacaoDataSet;
window.VerificaConfirmacaoAction = VerificaConfirmacaoAction;
window.CarregarCheckTreeView = CarregarCheckTreeView;
window.aplicarCriptografia = aplicarCriptografia;
window.CustomStoreArray = CustomStoreArray;
window.setDatePicker = setDatePicker;
window.createFormRepeater = createFormRepeater;
window.createNtcGrid = createNtcGrid;
window.createNtcLinkAnnotation = createNtcLinkAnnotation;
window.Layout = Layout;
window.executeActionFromPartial = executeActionFromPartial;
window.configureDatepicker = configureDatepicker;
window.createDropdownButton = createDropdownButton;
window.createFooterToolbuttons = createFooterToolbuttons;
window.openPdf = openPdf;
window.gridManager = gridManager;
window.getToolButtonAction = getToolButtonAction;
window.createNtcMemoAnnotation = createNtcMemoAnnotation;
window.ControlType = ControlType;
window.createWizardNavigationToolbar = createWizardNavigationToolbar;
window.GridActionHelper = GridActionHelper;
window.fixRowValues = fixRowValues;
window.widgetManager = widgetManager;
window.ActExecuteProcesso = ActExecuteProcesso;
window.clearAllReponseBox = clearAllReponseBox;
window.broadcastManager = brodcastManager;
window.axios = axios;
window.downloadArquivoTemp = downloadArquivoTemp;

// #region nWebUtil
window.CadastroGetImputData = CadastroGetImputData;
window.CadastroExecuteAction = CadastroExecuteAction;
window.OperacaoCadastro = OperacaoCadastro;
window.FormatErrorMessage = FormatErrorMessage;
window.DoExecuteReport = DoExecuteReport;
window.DoExecuteReportWithParams = DoExecuteReportWithParams;
window.AJaxCadastroExecuteMethodGetProperty = AJaxCadastroExecuteMethodGetProperty;
window.AJaxProcessoExecuteMethodGetProperty = AJaxProcessoExecuteMethodGetProperty;
window.RemoverTabCadastro = RemoverTabCadastro;
window.RestoreTabsCadastro = RestoreTabsCadastro;
window.AbrirProcesso = AbrirProcesso;
window.AbrirCadastro = AbrirCadastro;
window.AbrirProcessoModal = AbrirProcessoModal;
window.FrameModalLoad = FrameModalLoad;
window.ProcessoExecuteAction = ProcessoExecuteAction;
window.RetornarData = RetornarData;
// #endregion nWebUtil

window.qNotifier = qNotifier;
window._ = _;
window.bootbox = bootbox;

locale('pt-Br');
loadMessages(ptMessages);
registerPrototypes();
Initializer.init();

qGrid.init();