import { FormState } from "./nCadastro";
import FormManager from "./FormManager";
import { itsToUseLookupInside } from "./nLookUp";
import { ControlType, Field, Formulario } from './nFormulario';
import { NavigateWizard } from '../ts/components/wizard-navigation/wizard-navigation';
import { getFormatOptions } from "./setDatepicker";
import { AjaxAutoCompleteField, FormatErrorMessage, openRequiredSection } from "./nWebUtil";

export class nFraControl {
	static nextFocus(e, shiftKeyPressed) {
		let { classname, alias } = $(e).data();
		let form = FormManager.byname(classname, alias)
		var elementosFormulario = (classname) ? $(`div[id$="${classname}"]`).find('.cad-control') : $('.cad-control');
		var indiceAtual = elementosFormulario.index(e);

		while (indiceAtual <= elementosFormulario.length) {
			indiceAtual = indiceAtual + (shiftKeyPressed || 1);
			var proximoElemento = elementosFormulario[indiceAtual];

			if (proximoElemento == null) {
				$(e).blur();

				if (indiceAtual > 0) {
					if (form.estado === FormState.cadNavegando && $.data(e[0], 'original-value') != e.val()) {
						form.habilitarSalvar(true);
					}
					if (form.salvarDadosAutomatico) {
						nFraControl.ExecuteOrPost(classname, alias);
					}
					else if (classname == 'TnDMSelecao') {
						$('#btnDefaultSubmit').trigger('click');
					}

					break;
				}
				else {
					if (elementosFormulario.length > 1) {
						indiceAtual = elementosFormulario.length;
					} 
					else {
						if (form.salvarDadosAutomatico) {
							nFraControl.ExecuteOrPost(classname, alias);
						}
						break;
					}
				}
			}
			else if (!proximoElemento.disabled) {
				if (proximoElemento.type != 'hidden' && !$(proximoElemento).parents('div[id^="formField"]').hasClass('hide')) {
					const isInRangeVisible = (headerHeight, elOffsetTop) => ((elOffsetTop - headerHeight - $(window).scrollTop()) < 0);
					const agrupamento = $(proximoElemento).parents('div#main_accordion_Credito');
					let headerHeight = Math.max($('#kt_header').height() + $('#kt_subheader').height(), 200); // header + subheader + spread
					let elOffsetTop = $(proximoElemento).offset().top;

					if (agrupamento.length > 0 && agrupamento.find('.card-title').hasClass('collapsed')) {
						agrupamento.find('.card-title').click();
					}

					if ($(proximoElemento).is(':hidden')) {
						nFraControl.navigateTab({ isNext: shiftKeyPressed == 1 });
					}

					if (isInRangeVisible(headerHeight, elOffsetTop)) {
						setTimeout(() => KTUtil.scrollTo(proximoElemento, elOffsetTop - headerHeight));
					}

					$(proximoElemento).focus();
					$(proximoElemento).select();

					break;
				}
			}
		}
	}

	static navigateTab({ isNext }) {
		const getNextIndex = (isNext, nextIndex, limit) => (isNext ? Math.min(nextIndex + 1, limit) : Math.max(nextIndex - 1, 0));
		const isHidden = (li, index) => li.eq(index).is(':hidden');
		const getElements = () => {
			let ulSelector = $('#kt_content [data-id="tabitens"]').exists();

			return {
				ulSelector,
				liFirst: ulSelector ? ulSelector.eq(0).find('li') : null,
				liSecond: ulSelector ? ulSelector.eq(1).find('li') : null,
				liActive: ulSelector ? ulSelector.eq(0).find('.kt-nav__item--active') : null
			}
		}
		let { ulSelector, liFirst, liSecond, liActive } = getElements();

		if (ulSelector) {
			let index = liFirst.index(liActive);
			let length = liFirst.length;
			let nextIndex = getNextIndex(isNext, index, length)

			while (isHidden(liFirst, nextIndex) && isHidden(liSecond, nextIndex)) {
				nextIndex = getNextIndex(isNext, nextIndex, length - 1);
			}

			if (index !== nextIndex) {
				liFirst.eq(nextIndex).find('a').click();
			}
		}
	}

	static ExecuteOrPost(formClass, formAlias) {
		const ABtnSalvar = nFraControl.getBtnSalvarWidget(formClass);
		let form = FormManager.byname(formClass, formAlias)

		if (ABtnSalvar.length > 0) {
			NavigateWizard({
				actionname: ABtnSalvar.data('action'),
				sender: ABtnSalvar.data('name'),
				form,
			});
		} 
		else {
			let action = nFraControl.getActionNameOnLastField(form);
		
			form.executeAction(action);
		}
	}

	static getActionNameOnLastField(form) {
		switch(form.tipoObjeto) {
			case 'ntoCadastro': return 'actDataSetPostExecute';
			default: return 'ActionExecutarExecute';
		}
	}

	static getBtnSalvarWidget(formClass) {
		return $(`#frm${formClass}`).find('button[id^="widget_title"]');
	}

	static FraControlKeyPress(event) {
		const { currentTarget } = event;

		if ((event.altKey) && (event.which == 40)) { //Alt + Down
			$('#' + $(event.target).attr('data-button')).click();
		} 
		else if (currentTarget.tagName.match(/textarea/i) && event.ctrlKey && event.which === 13) { // (ctrl + enter) -> \n
			const { value, selectionStart, selectionEnd } = currentTarget;

			currentTarget.value = `${value.slice(0, selectionStart)}\n${value.slice(selectionEnd)}`;
			currentTarget.selectionEnd = currentTarget.selectionStart = selectionStart + 1;
		}
		else {
			if (event.which == 13) { //enter, 
				if ($(this).data('classname') == 'TnDMSelecao' && event.ctrlKey) { 
					$('#btnDefaultSubmit').trigger('click');
				}
				else {
					var shiftKeyPressed = (event.shiftKey) ? -1 : 1;

					event.preventDefault();

					if ($(event.currentTarget).data('haschange')) {
						$(event.currentTarget).trigger('change', event);
						return;
					}

					nextFocus($(this), shiftKeyPressed);
				}
			}
		}
	}

	static FraControlChange(event) {
		const getField = (el) => {
			const element = $(el).hasClass('datepicker') ? $(el).parent().siblings('input.hasdatepicker') : $(el);

			return 	element.data('q-field');
		}
		
		let field = getField(event.target)
		let form = field.InstanciaFormulario;

		if ((FormManager.podeEventoChangeFields) && (form.estado !=FormState.cadInsert) && (form.estado !=FormState.cadAlterando)) {
			if (field) {
				if (field.hasatencao()) field.removeatencao();
				if (field.required() && !field.hasvalue() && (field.haspicker() || !field.oculto()) && field.enabled)
					field.setatencao();
			}

			if (!form.element.hasClass('kt-login__form')) {
				form.changeState(FormState.cadAlterando);
			}
		}
	}

	static ValidarCamposObrigatorios( /** @type {Formulario} */ form) {
		var houveproblemas = false;
		var listacampos = [];

		form.fields.forEach(function (/** @type {Field} */ field) {
			if (field.required() && !field.hasvalue() && ((field.haspicker() && !field.hasPickerValid()) || !field.oculto()) && field.enabled) {
				houveproblemas = true;
				listacampos.push(field.nome);
				field.setatencao();
				openRequiredSection(field);
			}
		});

		if (houveproblemas) {
			console.log('Campos obrigatórios: ' + listacampos);
			FormatErrorMessage('Campos obrigatórios não preenchidos, verificar os campos em vermelho.');
		}

		return !houveproblemas;
	}

	static focusInputFunc({ element, controlName, multiColumn }) {
		const sender = element || document.getElementById(controlName);
		const { classname, alias } = $(sender).data();
		const form = FormManager.byname(classname, alias);

		if ((form != null) && ((!form.hasRecord()) && (form.tipoObjeto == 'ntoCadastro')) && !form.datasetInsertExecuted) {
			form.datasetInsertExecuted = true;
			form.executeAction('actDataSetInsertExecute');

			return;
		}

		const fieldName = ($(sender).prop('name') || '').split('.')[1];
		const /** @type {Field} */ Afield = form.fieldbyName(fieldName);

		if (!Afield) return;

		if ((sender.value == '')) {
			if (Afield.autoincrementar) {
				AjaxAutoCompleteField(Afield);
			}
		}
		else {
			const fieldComponent = Afield.componente;

			if (itsToUseLookupInside(multiColumn) && fieldComponent.data("haslinklookup")) {
				if (Afield.haspicker()) {
					const datepickerElement = Afield.getDatepickerElement();
					const { mask } = datepickerElement.data('mask');
					const { momentFormat } = getFormatOptions(mask);
					const value = moment(fieldComponent.val(), 'YYYY-MM-DD');

					datepickerElement.val(value.isValid() ? value.format(momentFormat) : '');
				}
				else {
					fieldComponent.val(fieldComponent.data("value"));
					$(fieldComponent).unmask();
					$.applyDataMask(fieldComponent);
				}
			}
		}
	}
}