import Api, { SetRequestDebounceConfig } from "../api";

export type GetGridConfigType = 'get-grid-config';

export function GetGridConfigConfig(): SetRequestDebounceConfig<GetGridConfigType> {
    return {
        type: 'get-grid-config',
        config: {
            arrayPropName: '_ANome',
            useURLSearchParams: true,
            axiosConfig: {
                method: 'post',
                url: 'nHttpServicos/GetGridConfig'
            }
        }
    }
}

export const GetGridConfig = (gridName: string) => {
    return Api.requestWithDebounce<any, string>({
        type: 'get-grid-config',
        requestData: {
            urlParams: gridName
        }
    });
};
