import { Field } from "../../../js/nFormulario";
import Api, { SetRequestDebounceConfig } from "../api";

export type RequestDadosLookupDebounceType = 'dados-lookup';

export function DadosLookupDebounceConfig(): SetRequestDebounceConfig<RequestDadosLookupDebounceType> {
    return {
        type: 'dados-lookup',
        config: {
            arrayPropName: '_ALookupArray',
            debounceTime: 150,
            axiosConfig: {
                url: 'nHttpServicos/DadosLookup',
                method: 'post',
            },
        }
    };
}

interface RequestDadosLookupProps {
    _AConsulta: string;
    _ALookupkeyfieldsValues: string;
    _AResultField: string;
    _AControleResult: string;
    _ADMClassName: string;
    _AAlias: string;
    _AField?: Field;
    _AOrigem: 'lookup';
}

type DadosLookupResponse = DadosLookupResponseSuccess | DadosLookupResponseError;

interface DadosLookupResponseError {
    CampoResult: string; // _AResultField
    Campos: string; // _ALookupkeyfieldsValues JSON stringified
    Consulta: string; // _AConsulta
    Controle: string; // _AControleResult
    Objeto: string; // _ADMClassName
    erro: string;
}

interface DadosLookupResponseSuccess {
    a: number
    Class: string;
    EhLookup: 'sim';
    _AControleResult?: string;
    Fields?: Array<{
        [key: string]: string;
    }>;
}

export const RequestDadosLookup = ({ _AAlias, _AConsulta, _AControleResult, _ADMClassName, _ALookupkeyfieldsValues, _AResultField }: RequestDadosLookupProps) => {
    return Api.requestWithDebounce<DadosLookupResponse, RequestDadosLookupProps>({
        type: 'dados-lookup',
        requestData: {
            bodyData: {
                _AConsulta,
                _AResultField,
                _AControleResult,
                _ADMClassName,
                _AAlias,
                _AOrigem: 'lookup',
                _ALookupkeyfieldsValues: _ALookupkeyfieldsValues,
            }
        }
    });
};