import { InputBlock } from "../input-block/input-block";
import { Label as getLabel } from "../label/label";
import { ControlElementCreator, Field } from "../types";
import { LookupDescriptionSearch } from "./lookup-description-search";
import { LookupValueSearch } from "./lookup-value-search";
import classNames from 'classnames';
import { FraControlElement } from "../fra-control-element/fra-control-element";

export const NtcLinkEdit: ControlElementCreator = (props) => {
    let wrapper = getWrapper(props);
    let label = getLabel(props);
    let inputBlock = InputBlock(props);
    let input = getInput(props);
    let controlElement = FraControlElement(props);

    wrapper.append(input);

    return inputBlock
        .append(label)
        .append(wrapper)
        .append(controlElement);
}

const getWrapper: ControlElementCreator = ({ formProp: { hasSessionSelecao, MultiColuna } }) => {
    return $('<div>')
        .addClass(classNames({
            'input-group': true,
            'col-12': !MultiColuna,
            'col-sm-9': !MultiColuna,
            'col-lg-7': !MultiColuna// && hasSessionSelecao
        }))
}

const getInput: ControlElementCreator<Field, JQuery<HTMLElement> | JQuery<HTMLElement>[]> = (props) => {
    const { item } = props;

    return item.LinkLookupDescShowFields ? LookupDescriptionSearch(props) : LookupValueSearch(props);
}