import FormManager from "../../../../js/FormManager";
import { Formulario } from "../../../../js/nFormulario";
import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { Button, ButtonVariation } from "../button";
import { getStringDataAction } from "../util/action-data";

interface ExecuteButtonProps {
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'Class' | 'Alias' | 'CadCons' | 'TopicoAjuda'>;
    variation?: ButtonVariation;
}

export const ExecuteButton = ({ DefinicaoObjetos: { Class, Alias = '', CadCons, TopicoAjuda }, variation }: ExecuteButtonProps) => {
    const caption = 'EXECUTAR';

    FormManager.shortCuts.bind({ 
        Class, 
        Alias, 
        caption, 
        handler: (event: Event, form: Formulario) => {
            form.executeAction('ActionExecutarExecute');
        }
    });
    
    return $(Button({
        variation: variation || "primary",
        attr: `id="btnFiltrar" data-formid="frmParametros" data-n-onclick="ActionExecutarExecute" ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}`,
        text: caption,
        cssClass: 'ml-2'
    }))
};