import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { Button } from "../button";

interface FieldChooserButtonProps {
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'FormDetalhe' | 'Class' | 'Alias' | 'CadCons' | 'TopicoAjuda' | 'Pages' | 'Fields'>;
}

export const FieldChooserButton = ({ DefinicaoObjetos: { FormDetalhe, Class, Alias, CadCons, TopicoAjuda, Pages, Fields } }: FieldChooserButtonProps) => {
    const li = $(`<li class="kt-portlet__nav-item" data-class="${Class}" data-alias="${Alias}" data-cadcons="${CadCons}" data-topicoajuda="${TopicoAjuda}" style="display: inline">`);
    const btnGroup = $(
        `<div class="btn-group" id="fieldChooser${Class}${Alias}" data-id="fieldChooser" data-class="${Class}" data-alias="${Alias}" data-cadcons="${CadCons}" data-topicoajuda="${TopicoAjuda}">
            ${Button({
                variation: "tertiary",
                attr: 'data-toggle="dropdown"',
                icon: 'la-list',
                cssClass: 'ml-2 dropdown-toggle',
            })}
        </div>`);

    const dropdown = $(`<div class="dropdown-menu dropdown-menu-right" style="width: 300px;">`);
    const dropdownList = $(`<ul class="kt-nav">`).data({
        'pages': !FormDetalhe ? Pages : null,
        'fields': Fields,
        'class-name': Class,
        'alias': Alias,
    });

    dropdown.append(dropdownList);

    btnGroup.append(dropdown);

    return li.append(btnGroup);
}
