import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { Button } from "../button";
import { getCreateActionData, getStringDataAction } from "../util/action-data";

interface NavigationButtonProps {
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'Class' | 'Alias' | 'CadCons' | 'TopicoAjuda'>;
}

export const NavigationButton = ({ DefinicaoObjetos: { Class = '', Alias = '', CadCons = '', TopicoAjuda = '' } }: NavigationButtonProps) => {
    return [
        {
            iconClass: 'la-actDataSetPrior',
            text: 'ANTERIOR',
            action: 'actDataSetPriorExecute',
            iconPosition: 'before'
        },
        {
            iconClass: 'la-actDataSetNext',
            text: 'PRÓXIMO',
            action: 'actDataSetNextExecute',
            iconPosition: 'after'
        }
    ].map((btnConfig) => {
        const li = $(/*html*/
                `<li>${Button({
                    variation: 'tertiary',
                    attr: `id="${btnConfig.action}${Class}" data-n-onclick="${btnConfig.action}" ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}`,
                    cssClass: 'ml-2',
                    text: btnConfig.text,
                    icon: btnConfig.iconClass,
                    iconPosition: btnConfig.iconPosition as 'after' | 'before',
                    textAdaptability: true,
                })}</li>`
            )
            .attr({
                class: 'kt-portlet__nav-item',
                'data-class': Class,
                'data-alias': Alias,
                'data-cadcons': CadCons,
                'data-topicoajuda': TopicoAjuda,
            })
            .css('display', 'inline');

        return li;
    });
}