import { WidgetConfigBase } from "../types";

export interface TwButtonActiveConfig extends WidgetConfigBase {
    Text: string;
    Selected?: boolean;
    ButtonGroup?: number; 
    twButtonActive: true; 
}

interface TwButtonActiveProps {
    widget: TwButtonActiveConfig,
}

export const TwButtonActive = ({ widget: { Text, Selected = false, ButtonGroup = 0 }}: TwButtonActiveProps) => {
    const button = $(/*html*/`
        <button 
            class="btn btn-sm btn-q-secondary tw-button-active ${Selected ? 'active' : ''}"
            type="button"
            data-tw-button-group="${ButtonGroup}"
        >
            ${Text}
        </button>
    `);

    button.on('click', ({ target }) => {
        $(`button[data-tw-button-group="${ButtonGroup}"]`).removeClass('active');

        $(target).addClass('active');
    });

    return button;
}