import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { TwCxGridConfig } from "../types";
import { TwCxGrid } from "./tw-cx-grid";

export interface CreateTwCxGridProps {
    element: JQuery<HTMLElement>;
    widget: TwCxGridConfig;
    DefinicaoObjetos: DefinicaoObjetosConfig;
    Params?: {
        [key: string]: any;
    },
    colunas?: number; // if the container has "colunas" then grid will have the "col" class
}

export const createTwCxGrid = ({ element, widget, DefinicaoObjetos, Params, colunas }: CreateTwCxGridProps) => {
    $(element).replaceWith(TwCxGrid({
        DefinicaoObjetos,
        widget: {
            ...widget,
            colunas: colunas != undefined ? true : false,
        },
        Params,
     }));
};