import gridManager from '../../grid-manager/grid-manager';
import { TwCxGridConfig } from '../types';

export const disposeTwCxGrid = (widget: TwCxGridConfig) => {
    const deleteGrid = (gridName: string) => gridManager.delete(gridName);
    
    if (widget.Grid) {
        const gridConfig = getSingleGridConfig(widget);
        
        deleteGrid(gridConfig.nomegrid);
    }
    else if (widget.grids) {
        widget.grids.forEach((grid: any) => deleteGrid(grid.nomegrid))
    }
};

const getSingleGridConfig = (grid: TwCxGridConfig) => {
    if (typeof grid.Grid == 'string') {
        try {
            return JSON.parse(grid.Grid);
        }
        catch(e) {
            return {};
        }
    }
    
    return grid.Grid;
};