import { TwHomeAreaTrabalhoConfig, WidgetPropsBase } from "../types";

interface TwHomeAreaTrabalhoProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwHomeAreaTrabalhoConfig;
}

export const TwHomeAreaTrabalho = ({ widget }: TwHomeAreaTrabalhoProps) => {
    const { NomeAreaTrabalho, Descricao, LinkSaibaMais, Imagem } = widget;
    
    return $(`
        <div class="row desktop-home-wrapper">
            <div class="col-6">
                <div class="text-wrapper">
                    <h1 class="desktop-title"> 
                        Área De Trabalho 
                    </h1>
                    <h1 class="desktop-title"> 
                        <b> ${NomeAreaTrabalho} </b> 
                    </h1>
                    <p class="desktop-description"> ${Descricao} </p>
                    <a class="btn btn-q-action btn-sm" href="${LinkSaibaMais}" target="_blank">SAIBA MAIS</a>
                </div>
            </div>
            <div class="col-6">
                <div id="imagetw" class="row row-full-height imgWrapperDesktop">
                    <div class="card-body imgBackground-AreaTrabalho" style="background-image:url('data:image/png;base64,${Imagem}')" ></div> 
                </div>
            </div>
        </div>
    `);
}