import { WidgetConfigBase, WidgetPropsBase } from "../types";

export interface TwIframeConfig extends WidgetConfigBase {
    twIframe: true;
    link: string;
} 

interface TwIframeProps {
    widget: TwIframeConfig;
}

declare var KTApp: any;

export const TwIframe = ({ widget: { Name, link } }: TwIframeProps) => {
    const element = $(/*html*/
       `<div id="widget_${Name}" class="h-100">
            <iframe src="${link}" class="h-100 w-100  d-none" frameborder="0"></iframe>
        </div>`
    );

    blockElementUntilLoad(element, Name);

    return element;
};

const blockElementUntilLoad = (element: JQuery<HTMLElement>, name: string) => {
    (new MutationObserver((_, observer) => {
        if (!document.contains(element.get(0)!)) return;

        observer.disconnect();

        KTApp.block(`#widget_${name}`);
    })).observe(document.documentElement, { subtree: true, childList: true });

    element
        .find('iframe')
        .on('load', (event) => {
            KTApp.unblock(`#widget_${name}`);

            event.target.classList.remove('d-none');
        });
};