import { ScopeConfig } from "../../types/page-config/page-config";

export interface OpenPdfProps extends Pick<ScopeConfig, 'DefinicaoObjetos' | 'Params' | 'Conteudo'> {
    fileName: string;
    fileNameNhz: string;
}

export const openPdf = ({ DefinicaoObjetos, fileName, fileNameNhz, Params, Conteudo }: OpenPdfProps) => {
    const { Class, ToolButtons, TipoObjeto, TopicoAjuda } = DefinicaoObjetos;

    const params = {
        fileName,
        fileNameNhz,
        Params,
        DefinicaoObjetos: {
            Class,
            ToolButtons,
            TipoObjeto,
            TopicoAjuda,
        },
        Conteudo,
    };
    
	var mapForm = document.createElement("form");
    mapForm.target = "_blank";
    mapForm.method = "POST"; 
    mapForm.action = "RelatorioExibir";

    var mapInput = document.createElement("input");
    mapInput.type = "text";
    mapInput.name = "Scope";
    mapInput.value = btoa(JSON.stringify(params));
    mapForm.appendChild(mapInput);

    document.body.appendChild(mapForm);
    
	mapForm.submit();
	mapForm.remove();
};
