import { createFooterToolbuttons, ScopeConfigForToolButtons } from "../../components/toolbuttons/toolbuttons";
import { configureEnvioZenReportView } from "../envio-zen/envio-zen-report-view";

export interface ReportViewScopeConfig extends Pick<ScopeConfigForToolButtons, 'DefinicaoObjetos' | 'Params' | 'Conteudo'> {
    fileName: string;
    fileNameNhz: string;
}

export const RelatorioExibir = (Scope: string) => {
    const scope: ReportViewScopeConfig = JSON.parse(decodeURIComponent(atob(Scope)));
    const buttons = configureEnvioZenReportView(scope);
    const pdfEL = $('<object>').attr({
        data: `ArquivoTemp/${scope.fileName}`,
        width: '100%',
        standby: 'Carregando...',
        type: 'application/pdf',
        style: 'height: calc(100vh - 52px);',
    });

    scope.DefinicaoObjetos.ToolButtons.push(...buttons);

    $('#reportContainer').append([
        pdfEL,
        createFooterToolbuttons({
            ...scope,
            Class: scope.DefinicaoObjetos.Class,
        }),
    ]);
};

export interface OperacaoDataSetProps {
    _AClasse: string;
    _AAction: string;
    _AGrid: any;
    _ADataset: any;
    _AEhProcesso: boolean;
    _AParams: null | { [key: string]: string | number | boolean | null };
    _AOpcoes: { [key: string]: any };
    ignoreGlobalAction?: boolean;
}
