import { Field, GroupColumn, ToolButton } from "../../components/fra-control/types";
import { WidgetsConfig } from "../../components/widgets/types";

export interface ScopeConfig {
    Class: string;
    DefinicaoObjetos: DefinicaoObjetosConfig;
    
    EhModal?: boolean;

    Conteudo?: ConteudoConfig
    
    /** data to load */
    data?: {
        [key: string]: any;
    };

    Params?: {
        [key: string]: string;
    }
}

export interface DefinicaoObjetosConfig {
    AutoInsert?: string;
    BodyCols: number;
    CadCons: string;
    CaminhoMenu?: Array<{
        Index: string;
        Caption: string;
    }>;
    Caption: string;
    ChavePrimaria: string[];
    Class: string;
    ClassForm: string;
    ClassParent: string;
    ConsultaInativo: boolean;
    Conteudo?: any;
    DefinicaoDetalhes?: DefinicaoObjetosConfig[];
    Detalhes?: [];
    Fields: any[];
    FormRepeater?: boolean;
    IDRequest: number;
    JavaScript: string;

    MultiColuna: boolean;
    Name: string;
    Pages?: PageConfig[];
    TipoObjeto: string;
    ToolButtons: ToolButton[];
    TopicoAjuda: string;
    VerificaSelecao?: string[];
    Widgets: WidgetsConfig | false;
    configextra: any;

    requestId?: number;
    Alias?: string;
    DetailFields?: Array<string> | null;
    FiltroFixo?: Object | null;
    FormDetalhe?: boolean;
    MasterClass?: string | null;
    MasterFields?: Array<string> | null;

    ProcessoPadrao?: boolean;
    ProcessoMultiplo?: boolean;
    ntfCadPage?: boolean;
    ntfCadGrid?: boolean;
    ntfCadScrollBox?: boolean;

    WorkSpace?: boolean;
    ExibirExecutar?: boolean;
    ExibirBotoesNavegacao?: boolean;

    SalvarDadosAutomatico?: boolean;
}

export interface PageConfig {
    Nome: string,
    Fields: (Field | GroupColumn)[],
}

export interface ConteudoConfig {
    Origem?: string;
    ArquivosRelatorio?: ReportFile[];
}

export interface ReportFile {
    Caption?: string;
    Ext?: string;
    Arquivo?: string;
    CaptionTipo: string;
    Temp?: boolean;
    Converte?: boolean,
    Tipo?: string,
}