import TerserPlugin from 'terser-webpack-plugin';
import CssMinimizerPlugin from 'css-minimizer-webpack-plugin';
import { Configuration } from "webpack";

export default {
	mode: 'production',
	devtool: false,
	optimization: {
		minimizer: [
			new TerserPlugin({
				parallel: true,
				terserOptions: {
					compress: {
						pure_funcs: ["console.log"],
					}
				}
			}),
			new CssMinimizerPlugin()
		]
	},
	ignoreWarnings: [
        () => true
    ]
} as Configuration;